package ShowXPath.StackNode;

import java.util.*;
import java.io.*;

import ShowXPath.TreeNode.*;

public class LString implements LStackNode
{
	private String _value;
	private final static String _type = "LString";

	public String type()
	{
		return _type;
	}

	public LString(String string)
	{
		_value = string;
	}

	public String toString()
	{
		return _value;
	}

	public String getStringValue()
	{
		return _value;
	}

	public void concat(LString s)
	{
		_value = _value + s.toString();
	}

	public LString toLString()
	{
		return this;
	}

	public LBoolean toLBoolean()
	{
		if (_value.length() > 0)
		{
			return new LBoolean(true);
		}
		else 
		{
			return new LBoolean(false);
		}
	}

	public LNumber toLNumber()
	{
		return new LNumber(_value);
	}
	
	public boolean equals(LStackNode node)
	{
		
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				LTreeNode n = (LTreeNode)i.next();
					
				if (_value.equals(n.getStringValue()))
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			LBoolean b = toLBoolean();
			return (b.getValue() == ((LBoolean)node).getValue());
		}
		else if (node instanceof LString)
		{
			return _value.equals(((LString)node).toString());
		}
		else if (node instanceof LNumber)
		{
			double number = toLNumber().getValue();
			return number ==
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}
	
	public boolean less(LStackNode node)
	{
		double number = toLNumber().getValue();
		
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				LTreeNode n = (LTreeNode)i.next();
				double nnumber = new LString(n.toString()).toLNumber().getValue();
				
				if (number < nnumber)
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return number <
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return number <
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return number <
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}

	public boolean greater(LStackNode node)
	{
		double number = toLNumber().getValue();
		
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				LTreeNode n = (LTreeNode)i.next();
				double nnumber = new LString(n.toString()).toLNumber().getValue();
				
				if (number > nnumber)
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return number >
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return number >
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return number >
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}

	public boolean lessEquals(LStackNode node)
	{
		double number = toLNumber().getValue();
		
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				LTreeNode n = (LTreeNode)i.next();
				double nnumber = new LString(n.toString()).toLNumber().getValue();
				
				if (number <= nnumber)
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return number <=
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return number <=
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return number <=
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}

	public boolean greaterEquals(LStackNode node)
	{
		double number = toLNumber().getValue();
		
		if (node instanceof LNodeset)
		{
			ListIterator i = ((LNodeset)node).listIterator();

			while (i.hasNext())
			{
				LTreeNode n = (LTreeNode)i.next();
				double nnumber = new LString(n.toString()).toLNumber().getValue();
				
				if (number >= nnumber)
				{
					return true;
				}
			}
			return false;
		}
		else if (node instanceof LBoolean)
		{
			return number >=
				((LBoolean)node).toLNumber().getValue();
		}
		else if (node instanceof LString)
		{
			return number >=
				((LString)node).toLNumber().getValue();
		}
		else if (node instanceof LNumber)
		{
			return number >=
				((LNumber)node).getValue();
		}
		else
		{
			return false;
		}
	}
}
