package ShowXPath.TreeNode;

import java.util.*;
import ShowXPath.StackNode.*;

public abstract class LTreeNode
{
	// TODO:
	//   1. set the ID attribute properly.
	//   2. The _id is the generate_id value;
	protected double _order;
	private static int _static_id = 0;
	private int _id;
	private String _XMLID;
	private String _baseURI = null;
	private String _namespace = null;

	public void setXMLID(String id)
	{
		_XMLID = id;
	}

	public abstract String getLang();

	public String getXMLID()
	{
		return _XMLID;
	}

	public String getURI()
	{
		return _baseURI;
	}

	public String getNodeNamespace()
	{
		return _namespace;
	}

	public void setURI(String uri)
	{
		_baseURI = uri;
	}

	public void setNodeNamespace(String namespace)
	{
		_namespace = namespace;
	}

	public abstract String toString();

	public void setOrder(double order)
	{
		_order = order;
	}

	public double getOrder()
	{
		return _order;
	}

	public static  void resetID()
	{
		_static_id = 1;
	}

	public void setID()
	{
		_id = _static_id;
		_static_id++;
	}

	public int getID()
	{
		return _id;
	}

	public LNodeset root()
	{
		LTreeNode n = null;
		LNodeset list = parent();
		while (list.size() > 0)
		{
			n = (LTreeNode) list.getFirst();
			list = n.parent();
		}
		list.add(n);
		return list;
	}

	public abstract LRoot getRoot();

	public abstract LTreeNode getParent();

	public abstract String getStringValue();

	public abstract String getName();

	public abstract String getLocal_name();

	public abstract String getNamespace();

	public abstract String getNamespace_uri();
	
	public abstract String showNode();

	public abstract LNodeset parent();
	
	public abstract LNodeset child();
	
	public abstract LNodeset ancestor();
	
	public abstract LNodeset self();
	
	public abstract LNodeset ancestor_or_self();
	
	public abstract LNodeset descendent();
	
	public abstract LNodeset descendent_or_self();
	
	public abstract LNodeset attribute();
	
	public abstract LNodeset following();
	
	public abstract LNodeset following_sibling();
	
	public abstract LNodeset preceding();
	
	public abstract LNodeset preceding_sibling();
	
	public abstract LNodeset namespace();

	public abstract String type();
}
